/************************************************
 *
 *       Filename: edit.c
 *        Version: 0.2
 *         Author: little
 *     	      MSN: littlekrash@gmail.com
 *
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "fileio.h"
#include "edit.h"
#include "search.h"

void freeSubLink(datInfo *counter) 
{
	datInfo *p,*temp;
	p = counter->subLink;
	if(p) {
		while(p->subLink) {
			temp = p;
			p = p->subLink;
			free(temp);
		}
		free(p);
	}
}

//获取物品类型
unsigned char getType_WP(int id)
{
	if(id < 0x0BB8 || id > 0x0CBA) return NONE;
	else return itemMap[id - 0x0BB8];
}
//获取图谱类型
unsigned char getType_TP(int id)
{
	if(id > 0x1FE3 && id < 0x1F40) return NONE;
	else return JIAGONG[id -0x1F40];
}

void d2p(int *out,int *in,int num)
{
	int i,j;
	for(i = 0;i < num;i++)
	{
		*out = 0;
		for(j = 0;j < 20;j++)
			if((d2pMap[j] & 0XFFFF0000) == (*in & 0xFFFF0000)) *out = (j + 1) * 5;
		in++;
		out++;
	}
}

void p2d(int *out,int *in,int num)
{
	int i;
	for(i = 0;i < num;i++) {
		if(*in <= 0 || *in > 100) *out = 0;
		else *out = d2pMap[*in/5 - 1];
		in++;
		out++;
	}
}
//添加或者删除图谱 
int editTP(int id,unsigned char operate)
{
	unsigned int type;
	datInfo *count,*p;
	datInfo *newTP;
	type = getType_TP(id);
	if(type == NONE) return EXIT_FAIL;
	count = findDatInfo(MAKE_INFO(type,COUNTER_TP,NONE,1));
	p = count;
	if(count->subLink) {
		do {
			p = p->subLink;
			if(STR2INT(p->data) == id) {
				if(operate == DEL) {
					p->size = 0;							//这样就可以了
					STR2INT(count->data)--;
				}
				return EXIT_OK;
			}
		}while(p->subLink);
	}
	//没有找到
	if((newTP = (datInfo *)malloc(sizeof(datInfo) + INTLEN) ) == NULL)
		return EXIT_FAIL;
	p->subLink = newTP;
	newTP->next = NULL;
	newTP->subLink  = NULL;
	newTP->data = (char *) newTP + sizeof(datInfo);
	newTP->size = INTLEN;
	STR2INT(newTP->data) = id;
	STR2INT(count->data)++;
	return EXIT_OK;
}


//修改物品 n = 0 时删除物品
int itemAdd(int ID,int n)
{
	unsigned int info;
	unsigned char itemType;
	datInfo *gcount,*count;
	item *it;
	datInfo *p;
	itemType = getType_WP(ID);
	if(itemType == NONE) return EXIT_FAIL;
	//得到全局计数 
	info = MAKE_INFO(NONE,COUNTER_WP,NONE,LAST_EC);		//物品在最后在个EC_SERIALIZE_FLAG里面
	gcount = findDatInfo(info) ;
	//这类物品计数
	info = MAKE_INFO(itemType,COUNTER_WP,NONE,LAST_EC);
	count = findDatInfo(info);
	p = count;
	if(count->subLink) {
		do {
			p = p->subLink;
			it = (item *) p->data;
			if(it->ID == ID && n) {
				it->num = n;
				return EXIT_OK;
			}
			else if(it->ID == ID && n == 0) {
				p->size = 0;
				//把计算减一
				STR2INT(gcount->data)--;
				STR2INT(count->data)--;
				return EXIT_OK;
			} 
		}while(p->subLink);
	}
	//加一个新的物品
	datInfo *newItem;
	if((newItem = (datInfo *)malloc(sizeof(datInfo) + sizeof(item)) ) == NULL)
		return EXIT_FAIL;
	p->subLink = newItem;
	newItem->subLink = NULL;
	newItem->next = NULL;
	newItem->data =(char*) newItem + sizeof(datInfo);
	newItem->size = 3*INTLEN;
	newItem->info = info;
	it = (item *)newItem->data;
	it->serial = STR2INT(gcount->data);
	it->num = n;
	it->ID = ID;
	STR2INT(gcount->data)++;
	STR2INT(count->data)++;
	return EXIT_OK;
}
//高级模式中调用，用于手动修改标志字符串后面的值,值是一个int型的
void editValue(unsigned int type,int val)
{
	char *buf;
	int len,index;
	datInfo *p;
	p = findDatInfo(type);
	buf = p->data;
	len = INTLEN + STR2INT(p->data);
	buf += len;
	STR2INT(buf) = val;
	index = (type & 0xFF);
	if(index >= 13 && index <= 94) {
		index += 85;
		editValue((type & 0xFFFFFF00) | (index & 0xFF),val);
	}
}

//高级模式中调用，用于手动修改标志字符串后面的值,值是个字符串,buf是用字符计数存的字符串
void editString(unsigned int type,char *buf)
{
	char *ptr;
	int len,size;
	datInfo *p,*newNode;
	size = STR2INT(buf);
	if( (newNode = (datInfo *)malloc(sizeof(datInfo) + 2*INTLEN + size*sizeof(char))) == NULL ) 
			return;
	newNode->size = 2*INTLEN + size;
	newNode->next = NULL;
	newNode->subLink = NULL;
	p = findDatInfo(type);
	ptr = p->data;
	len = INTLEN + STR2INT(ptr);
	p->size = len;
	ptr += len;
	
	if(p->next) newNode->next = p->next;
	if(p->subLink) {
		newNode->subLink = p->subLink;
		p->subLink = NULL;
	}

	p->next = newNode;
	newNode->data = (char*)newNode + sizeof(datInfo);
	memcpy(newNode->data,buf,(INTLEN + size));
	ptr = newNode->data + INTLEN +size;
	STR2INT(ptr) = size;
}
//加某系仙术
int addSerialX(unsigned char type,unsigned char who)
{
	int i;
	int buf[6 + 1 + 6*2] = {
		0,0,0,0,0,0,
		0,0,5,0,5,0,
		6,0,6,0,7,0,7};
	datInfo *counter,*newNode;
	
	newNode = (datInfo *)malloc(sizeof(datInfo) + 19*sizeof(int));
	if(newNode == NULL) return EXIT_FAIL;

	counter = findDatInfo(MAKE_INFO(type,COUNTER_X,who,212));
	freeSubLink(counter);				//清除该系原有仙术
	counter->subLink = newNode;
	newNode->size = 19*sizeof(int);
	newNode->subLink = NULL;
	newNode->next = NULL;
	newNode->data = (char*)newNode + sizeof(datInfo);

	STR2INT(counter->data) = 6;
	buf[6] = 6;
	for(i = 0;i < 6;i++) {
		buf[i] = 0x1388 + 6*(type -1) + i;
		buf[7 + 2*i] = buf[i];
	}
	memcpy(newNode->data,buf,19*sizeof(int));
	return EXIT_OK;
}
//加某人所有技能
int addSerialSkill(unsigned char who)
{
	int i,init,n;
	int buf[7] = {0};						//天河可以有七个技能
	datInfo *counter,*newNode;
	newNode = (datInfo *)malloc(sizeof(datInfo) + 7*sizeof(int));
	if(newNode == NULL) return EXIT_FAIL;

	init = 0x157C + 6*(who - 1);
	if( who == TIANHE ) {
		n = 7;
	}
	else {
		init++;
		n = 6;
	}
	counter = findDatInfo(MAKE_INFO(NONE,COUNTER_J,who,212));

	freeSubLink(counter);
	counter->subLink = newNode;
	STR2INT(counter->data) = n;
	newNode->size = n*sizeof(int);
	newNode->subLink = NULL;
	newNode->next = NULL;
	newNode->data = (char*)newNode + sizeof(datInfo);
	for(i = 0;i < n;i++) {
		buf[i] = init + i;
	}
	memcpy(newNode->data,buf,n*sizeof(int));
	return EXIT_OK;
}
//添加某类物品
void haveAllItem(unsigned char type,int num)
{
	int i,t;
	for(i = 0X0BB8;i <= 0X0CBA;i++) {
		t = getType_WP(i);
		if( t == type ) itemAdd(i,num);
		else if( t != STORY) itemAdd(i,num);
	}
}

//添加某类图谱
void haveAllTP(unsigned char type) 
{
	int i,t;
	datInfo *counter;
	counter = findDatInfo(MAKE_INFO(type,COUNTER_TP,NONE,1));
	for(i = 0x1F40;i <= 0x1FE3;i++) {
		t = getType_TP(i);
		if(t == type)editTP(i,ADD);
		else editTP(i,ADD);
	}
}
//把某人仙术或者技能放入数组a中
void getXJ(unsigned char main,unsigned char sub,unsigned char who,int *a)
{
	int n;
	datInfo *counter,*p;
	counter = findDatInfo(MAKE_INFO(main,sub,who,212));
	n = STR2INT(counter->data);
	p = counter->subLink;
	*a++ = n;
	if(n && p->size == INTLEN) {
		while(n--) {
			*a = STR2INT(p->data);
			p = p->subLink;
			a++;
		}
	}
	else if(n && p->size > INTLEN) memcpy(a,p->data,n*sizeof(int));
}

void getX(unsigned char type,unsigned char who,int *a)		//a至少为7 计数+内容
{
	getXJ(type,COUNTER_X,who,a);
}

void getJ(unsigned char who,int *a)		//a至少为7 计数+内容
{
	getXJ(NONE,COUNTER_J,who,a);
}

//根据数组a中的内容设定仙术 a格式为计数 + 内容
int setX(unsigned char type,unsigned char who,int *a)
{
	int i,n;
	int buf[6 + 1 + 6*2] = {
		0,0,0,0,0,0,
		0,0,5,0,5,0,
		6,0,6,0,7,0,7};
	int *p;
	datInfo *counter,*newNode;

	newNode = (datInfo *)malloc(sizeof(datInfo) + 19*sizeof(int));
	if(newNode == NULL) return EXIT_FAIL;

	n = a[0];
	a++;
	p  = buf + 6 - n;
	counter = findDatInfo(MAKE_INFO(type,COUNTER_X,who,212));
	freeSubLink(counter);

	counter->subLink = newNode;
	newNode->size = (n*3 + 1)*sizeof(int);
	newNode->subLink = NULL;
	newNode->next = NULL;
	newNode->data = (char*)newNode + sizeof(datInfo);

	STR2INT(counter->data) = n;
	p[n] = n;									//无意义4字节
	for(i = 0;i < n;i++) {
		p[i] = *a++;
		p[2*i + n + 1] = p[i];					//
	}
	memcpy(newNode->data,p,(n*3 + 1)*sizeof(int));
	return EXIT_OK;
}

//根据数组a中的内容设定技能
int setJ(unsigned char who,int *a)
{
	int i,n;
	int buf[128] = {0};							//最多可以加128个
	datInfo *counter,*newNode;

	newNode = (datInfo *)malloc(sizeof(datInfo) + 128*sizeof(int));
	if(newNode == NULL) return EXIT_FAIL;

	counter = findDatInfo(MAKE_INFO(NONE,COUNTER_J,who,212));
	n = a[0];
	a++;

	freeSubLink(counter);
	counter->subLink = newNode;
	STR2INT(counter->data) = n;
	newNode->size = n*sizeof(int);
	newNode->subLink = NULL;
	newNode->next = NULL;
	newNode->data = (char*)newNode + sizeof(datInfo);
	for(i = 0;i < n;i++) {
		buf[i] = *a++;
	}
	memcpy(newNode->data,buf,n*sizeof(int));
	return EXIT_OK;
}
void writeEquipAttr(unsigned char type,int num,int *a)		//写入装备184个固定的属性,num为这种类型中的第几个装备
{
	int size;
	char *buf;
	datInfo *counter,*p;
	counter = findDatInfo(MAKE_INFO(type,COUNTER_ZB,NONE,(type + 1)));
	p = counter;
	while(num--) p = p->subLink;
	size = search(p->data,0x200,"\x80\xfb\x12\x00\x04\x00\x00\x00\x07\x00\x00\x00",12);
	if(size > 0) {
		buf = p->data + size - 32; 
		memcpy(buf,a,184);
	}
}
void getEquipAttr(unsigned char type,int num,int *a)	//读入装备184个固定属性到a
{
	int size;
	char *buf;
	datInfo *counter,*p;
	counter = findDatInfo(MAKE_INFO(type,COUNTER_ZB,NONE,(type + 1)));
	p = counter;
	while(num--) p = p->subLink;
	size = search(p->data,0x200,"\x80\xfb\x12\x00\x04\x00\x00\x00\x07\x00\x00\x00",12);
	if(size > 0) {
		buf = p->data + size - 32; 
		memcpy(a,buf,184);
	}
}
int d2pMap[20] = {
	0X3D4CCCCD,0X3DCCCCCD,0X3E19CCCD,0X3E4CCCCD,0X3E80CCCD,
	0X3E99CCCD,0X3EB3CCCD,0X3ECCCCCD,0X3EE6CCCD,0X3F00CCCD,
	0X3F0CCCCD,0X3F19CCCD,0X3F26CCCD,0X3F33CCCD,0X3F40CCCD,
	0X3F4CCCCD,0X3F59CCCD,0X3F66CCCD,0X3F73CCCD,0X3F80CCCD };
unsigned char itemMap[260] = {
1	/* B80B	止血草 */,
1	/* B90B	行军丹 */,
1	/* BA0B	护心丹 */,
1	/* BB0B	紫菁玉蓉膏 */,
1	/* BC0B	龙胆草 */,
1	/* BD0B	晗灵果 */,
1	/* BE0B	鼠儿果 */,
1	/* BF0B	还神丹 */,
1	/* C00B	四合寒香 */,
1	/* C10B	天仙玉露 */,
1	/* C20B	玉真散 */,
1	/* C30B	脂凝丸 */,
1	/* C40B	桂花芙蓉糕 */,
1	/* C50B	八公山豆腐 */,
1	/* C60B	炸馓子 */,
1	/* C70B	手抓饭 */,
1	/* C80B	红绿八宝饭 */,
1	/* C90B	鬼城麻辣鸡 */,
1	/* CA0B	百枣银杏粥 */,
1	/* CB0B	淮王鱼羹 */,
1	/* CC0B	醉枣 */,
1	/* CD0B	奶茶 */,
1	/* CE0B	醪酒 */,
1	/* CF0B	孟婆粥 */,
1	/* D00B	蜂王蜜 */,
1	/* D10B	济生散 */,
1	/* D20B	菩提凝冰露 */,
3	/* D30B	络灵瑶草 */,
1	/* D40B	扶摇仙果 */,
1	/* D50B	还魂香 */,
1	/* D60B	回生仙饮 */,
1	/* D70B	天香续命露 */,
1	/* D80B	血凝精 */,
1	/* D90B	八味檀香散 */,
3	/* DA0B	寒蟾露 */,
3	/* DB0B	火焰草 */,
3	/* DC0B	冰莲絮 */,
3	/* DD0B	风寒石 */,
3	/* DE0B	过风藤 */,
3	/* DF0B	土沉叶香 */,
3	/* E00B	毒龙胆 */,
3	/* E10B	大力丸 */,
3	/* E20B	龙穴石髓 */,
3	/* E30B	金蝉蜕 */,
3	/* E40B	金刚咒 */,
3	/* E50B	神行丸 */,
3	/* E60B	疾风符 */,
3	/* E70B	吉祥如意符 */,
3	/* E80B	灵运宝令 */,
3	/* E90B	紫地甘萝 */,
3	/* EA0B	龙须金藤 */,
3	/* EB0B	倚月蓉花 */,
3	/* EC0B	天心葵 */,
3	/* ED0B	通天丸 */,
3	/* EE0B	戒冥玉 */,
3	/* EF0B	晗光琉璃 */,
2	/* F00B	捆仙绳 */,
2	/* F10B	封咒符 */,
2	/* F20B	锁灵环 */,
2	/* F30B	无忧梦钤 */,
2	/* F40B	幽魔散 */,
2	/* F50B	迷魂散 */,
3	/* F60B	烟月神镜 */,
3	/* F70B	玄灵碧瑶 */,
3	/* F80B	幻界水晶 */,
3	/* F90B	影月神石 */,
5	/* FA0B	钉耙秘笈 */,
3	/* FB0B	土灵珠(?) */,
2	/* FC0B	密雨银芒 */,
2	/* FD0B	毒蜂巢 */,
2	/* FE0B	射影寒砂 */,
2	/* FF0B	封喉羽 */,
2	/* 000C	碧磷砂 */,
2	/* 010C	蛊 */,
2	/* 020C	无忧散 */,
2	/* 030C	凝酥软香 */,
2	/* 040C	软骨浆 */,
2	/* 050C	骷髅鼓 */,
2	/* 060C	大破天甲散 */,
2	/* 070C	南草乌 */,
2	/* 080C	地缚根 */,
2	/* 090C	五生牯铃 */,
2	/* 0A0C	丧门钉 */,
2	/* 0B0C	寒鸦羽 */,
2	/* 0C0C	梅花镖 */,
2	/* 0D0C	袖箭 */,
2	/* 0E0C	雷火珠 */,
2	/* 0F0C	透骨钉 */,
2	/* 100C	震天雷 */,
2	/* 110C	散花天女 */,
2	/* 120C	鸣风石 */,
2	/* 130C	涣神砂 */,
2	/* 140C	噬魂硝 */,
2	/* 150C	坠影含幽 */,
3	/* 160C	鸢尾香 */,
3	/* 170C	广藿香 */,
3	/* 180C	丁香 */,
3	/* 190C	青木香 */,
3	/* 1A0C	没药 */,
3	/* 1B0C	乳香 */,
3	/* 1C0C	龙脑香 */,
5	/* 1D0C	这是剑 */,
5	/* 1E0C	望舒剑 */,
5	/* 1F0C	长弓	 */,
5	/* 200C	古玉 */,
5	/* 210C	灵光藻玉 */,
5	/* 220C	玉腰弓 */,
5	/* 230C	帝女翡翠 */,
0	/* 240C	? */,
5	/* 250C	梭罗果 */,
5	/* 260C	鲲鳞 */,
5	/* 270C	光纪寒图 */,
5	/* 280C	天河剑 */,
5	/* 290C	红魄 */,
5	/* 2A0C	翳影枝 */,
5	/* 2B0C	后羿射日弓 */,
5	/* 2C0C	水灵珠 */,
5	/* 2D0C	炙炎石 */,
0	/* 2E0C	? */,
0	/* 2F0C	? */,
0	/* 300C	? */,
5	/* 310C	燧石 */,
0	/* 320C	? */,
0	/* 330C	? */,
0	/* 340C	? */,
0	/* 350C	? */,
5	/* 360C	九眼石 */,
4	/* 370C	黄铜矿 */,
4	/* 380C	辉铜矿 */,
4	/* 390C	斑铜矿 */,
4	/* 3A0C	青琅玕 */,
4	/* 3B0C	赤铁石 */,
4	/* 3C0C	玄武铁 */,
4	/* 3D0C 昆仑紫鸦乌 */,
4	/* 3E0C	昆吾沙 */,
4	/* 3F0C 耀金石 */,
4	/* 400C	自然金 */,
4	/* 410C 金红石 */,
4	/* 420C 紫金石 */,
4	/* 430C 蛇纹石 */,
4	/* 440C 天河石 */,
4	/* 450C 天青石 */,
4	/* 460C 紫晶石 */,
4	/* 470C 蟠龙玛瑙 */,
4	/* 480C 虹光琥珀 */,
4	/* 490C 羊脂白玉 */,
4	/* 4A0C	琅环碧玉 */,
4	/* 4B0C 绯云火石 */,
4	/* 4C0C 云母 */,
4	/* 4D0C 奇异石 */,
4	/* 4E0C 冰晶石 */,
4	/* 4F0C	烈火岩 */,
4	/* 500C 岩铁地魄 */,
4	/* 510C 雷魄晶 */,
4	/* 520C 霜露晶 */,
4	/* 530C 月长石 */,
4	/* 540C 火纹玉 */,
4	/* 550C 寒月冰魄 */,
4	/* 560C 黑曜石 */,
4	/* 570C 虎晴石 */,
4	/* 580C 云晶石 */,
4	/* 590C 浩英石 */,
4	/* 5A0C	黝碧石 */,
4	/* 5B0C 尖晶石 */,
4	/* 5C0C 银星晶魄 */,
4	/* 5D0C 日辉晶魄 */,
4	/* 5E0C 幽冥晶魄 */,
5	/* 5F0C 九转圣光石 */,
4	/* 600C 软星 */,
4	/* 610C	木炭 */,
4	/* 620C	凤首木 */,
4	/* 630C	枫木 */,
4	/* 640C	丝线 */,
4	/* 650C 蚕丝 */,
4	/* 660C	兽皮 */,
4	/* 670C	朱蛤涎 */,
0	/* 680C	? */,
4	/* 690C	赤脊骨 */,
4	/* 6A0C	灵骨突 */,
4	/* 6B0C	滴血翅 */,
4	/* 6C0C	七彩仙羽 */,
4	/* 6D0C	晨甘露 */,
3	/* 6E0C	元祖星空 */,
4	/* 6F0C	紫影瞳 */,
4	/* 700C	妖猫 */,
4	/* 710C	万棘针	 */,
4	/* 720C	筮金牙 */,
4	/* 730C	尖锐臼牙 */,
4	/* 740C	断魂散魄 */,
4	/* 750C	暗目珠 */,
4	/* 760C	珍珠蚌壳 */,
4	/* 770C	利刃爪 */,
4	/* 780C	狂暴利爪 */,
4	/* 790C	软鳞蜕 */,
0	/* 7A0C	? */,
4	/* 7B0C	鳞光甲 */,
4	/* 7C0C	娥女香 */,
4	/* 7D0C	百花醉仙露 */,
4	/* 7E0C	冰晶醉花蕊 */,
4	/* 7F0C	冰魂晶 */,
4	/* 800C	异精筋 */,
0	/* 810C	? */,
4	/* 820C	雪云毛 */,
4	/* 830C	五色茸 */,
4	/* 840C	萦魂绫 */,
4	/* 850C	摄魂花 */,
4	/* 860C	鬼骨火 */,
4	/* 870C	绿玉骨 */,
4	/* 880C	法螺 */,
4	/* 890C	紫金佛钵 */,
4	/* 8A0C	碎如意 */,
4	/* 8B0C	福寿果 */,
4	/* 8C0C	琼浆玉露 */,
4	/* 8D0C	青霜紫晶穗 */,
4	/* 8E0C	金芒石 */,
4	/* 8F0C	暗血凝脂 */,
4	/* 900C	花纹虎皮 */,
4	/* 910C	狂兽皮 */,
4	/* 920C	玄武甲片 */,
4	/* 930C	炼火珠 */,
4	/* 940C 火云鳞 */,
4	/* 950C	火云烈云带 */,
4	/* 960C	邪灵石 */,
4	/* 970C	残牛角 */,
4	/* 980C	尖韧角 */,
4	/* 990C	乌灵刃 */,
4	/* 9A0C	六阳剑柄 */,
4	/* 9B0C	青玉梭 */,
4	/* 9C0C	赤蛇涎 */,
4	/* 9D0C	青蛇涎 */,
4	/* 9E0C	毒蛛涎 */,
4	/* 9F0C	钩镰刺 */,
4	/* A00C	青幽液 */,
4	/* A10C	吸血针 */,
4	/* A20C	招财聚宝珠 */,
4	/* A30C	九狐尾绒 */,
4	/* A40C	烛龙之鳞 */,
4	/* A50C	神木影羽 */,
4	/* A60C	幽梦棱晶 */,
4	/* A70C	夜魅灵石 */,
4	/* A80C	绮梦魔珠 */,
5	/* A90C	不知名的剑 */,
0	/* AA0C	? */,
5	/* AB0C	凤凰花枝 */,
5	/* AC0C	机关箱 */,
5	/* AD0C	牌位 */,
5	/* AE0C	香炉 */,
5	/* AF0C	香囊 */,
0	/* B00C	? */,
5	/* B10C	开元追月弓 */,
5	/* B20C	红宝珠 */,
5	/* B30C	黄宝珠 */,
5	/* B40C	蓝宝珠 */,
5	/* B50C	一口梦千年 */,
5	/* B60C	紫蕴玄参 */,
5	/* B70C	点心 */,
4	/* B80C	无衣神水 */,
4	/* B90C	紫陌清风 */,
4	/* BA0C	濡润叶 */};
unsigned char JIAGONG[164] = {
	//96
2	/* 401F	习武 */,
2	/* 411F	修武 */,
2	/* 421F	精武 */,
2	/* 431F	心武 */,
2	/* 441F	真武 */,
2	/* 451F	破武 */,
2	/* 461F	形护 */,
2	/* 471F	志护 */,
2	/* 481F	毅护 */,
2	/* 491F	灵护 */,
2	/* 4A1F	心护 */,
2	/* 4B1F	神护 */,
2	/* 4C1F	镜灵 */,
2	/* 4D1F	迅影 */,
2	/* 4E1F	疾风 */,
2	/* 4F1F	神行 */,
2	/* 501F	吉祥 */,
2	/* 511F	福佑 */,
2	/* 521F	鸿运 */,
2	/* 531F	通灵 */,
2	/* 541F	藏魄 */,
2	/* 551F	蕴神 */,
2	/* 561F	水纹 */,
2	/* 571F	火纹 */,
2	/* 581F	雷纹 */,
2	/* 591F	风纹 */,
2	/* 5A1F	土纹 */,
2	/* 5B1F	水殇 */,
2	/* 5C1F	水融 */,
2	/* 5D1F	水御 */,
2	/* 5E1F	火殇 */,
2	/* 5F1F	火融 */,
2	/* 601F	火御 */,
2	/* 611F	雷殇 */,
2	/* 621F	雷融 */,
2	/* 631F	雷御 */,
2	/* 641F	风殇 */,
2	/* 651F	风融 */,
2	/* 661F	风御 */,
2	/* 671F	土殇 */,
2	/* 681F	土融 */,
2	/* 691F	土御 */,
2	/* 6A1F	元精 */,
2	/* 6B1F	凝神 */,
0	/* 6C1F	? */,
0	/* 6D1F	? */,
0	/* 6E1F	? */,
0	/* 6F1F	? */,
0	/* 701F	? */,
0	/* 711F	? */,
0	/* 721F	? */,
2	/* 731F	水毒 */,
2	/* 741F	火毒 */,
2	/* 751F	雷毒 */,
2	/* 761F	风毒 */,
2	/* 771F	土毒 */,
2	/* 781F	惊魂 */,
2	/* 791F	破甲 */,
2	/* 7A1F	断筋 */,
2	/* 7B1F	厄运 */,
2	/* 7C1F	扰灵 */,
2	/* 7D1F	冰咒 */,
2	/* 7E1F	炎咒 */,
2	/* 7F1F	雷咒 */,
2	/* 801F	风咒 */,
2	/* 811F	土咒 */,
2	/* 821F	吸魂 */,
2	/* 831F	夺魄 */,
2	/* 841F	集气 */,
0	/* 851F	? */,
2	/* 861F	连击 */,
2	/* 871F	定 */,
2	/* 881F	眠 */,
2	/* 891F	狂 */,
2	/* 8A1F	乱 */,
2	/* 8B1F	禁 */,
2	/* 8C1F	封 */,
2	/* 8D1F	镇魂 */,
2	/* 8E1F	格挡 */,
2	/* 8F1F	必中 */,
2	/* 901F	会心 */,
2	/* 911F	荆棘 */,
2	/* 921F	定免 */,
2	/* 931F	风免 */,
2	/* 941F	禁免 */,
2	/* 951F	眠免 */,
2	/* 961F	狂免 */,
2	/* 971F	乱免 */,
2	/* 981F	水之守护 */,
2	/* 991F	火之守护 */,
2	/* 9A1F	雷之守护 */,
2	/* 9B1F	风之守护 */,
2	/* 9C1F	土之守护 */,
2	/* 9D1F	生命守护 */,
0	/* 9E1F	? */,
2	/* 9F1F	怒气 */,
0	/* A01F ? */,
0	/* A11F ? */,
0	/* A21F ? */,
0	/* A31F ? */,
0	/* A41F ? */,
	//53
1	/* A51F	锋灵刃 */,
1	/* A61F	蕴华剑 */,
1	/* A71F	玉柄龙吟剑 */,
1	/* A81F	刺珏 */,
1	/* A91F	凝霜 */,
1	/* AA1F	玄瞑剑 */,
1	/* AB1F	鬼魁刃 */,
1	/* AC1F	定魂剑 */,
1	/* AD1F	崩鸣刃 */,
1	/* AE1F	碎痕 */,
1	/* AF1F	紫宵银月 */,
1	/* B01F	飞雯焕日 */,
1	/* B11F	慑天 */,
1	/* B21F	乌金剑 */,
1	/* B31F	望月 */,
1	/* B41F	太极双绝 */,
1	/* B51F	沉渊勾 */,
1	/* B61F	寒梅 */,
1	/* B71F	蛇影 */,
1	/* B81F	蟠龙爪 */,
1	/* B91F	流霜月魄刃 */,
1	/* BA1F	羿日焓灵刃 */,
1	/* BB1F	寒香枫木琴 */,
1	/* BC1F	松风卧云 */,
1	/* BD1F	散玉琴 */,
1	/* BE1F	鹤唳 */,
1	/* BF1F	赤羽琴 */,
1	/* C01F	璞玉琴 */,
1	/* C11F	碧血瑶琴 */,
1	/* C21F	司幽 */,
1	/* C31F	银角梳 */,
1	/* C41F	飐风发带 */,
1	/* C51F	菱页萦波梳 */,
1	/* C61F	紫阳冠 */,
1	/* C71F	赤金攒珠冠 */,
1	/* C81F	通天冠 */,
1	/* C91F	嵌玉披风 */,
1	/* CA1F	凤纹披风 */,
1	/* CB1F	沁雪白绫衫 */,
1	/* CC1F	霓裳羽衣 */,
1	/* CD1F	鲛绡 */,
1	/* CE1F	广袖流仙裙 */,
1	/* CF1F	避邪披风 */,
1	/* D01F	黑貂裘 */,
1	/* D11F	云纹细鳞甲 */,
1	/* D21F	翼云甲 */,
1	/* D31F	太极软甲 */,
1	/* D41F	玄武战袍 */,
1	/* D51F	金镂鞋 */,
1	/* D61F	鳞纹鞋 */,
1	/* D71F	凌波拾翠履 */,
1	/* D81F	翔鹰踏 */,
1	/* D91F ?	   */,
1	/* DA1F	望仙鞋 */,
	//9
3	/* DB1F	醉仙 */,
3	/* DC1F	招财 */,
3	/* DD1F	狐仙显灵 */,
3	/* DE1F	炙炎 */,
3	/* DF1F	幻风 */,
3	/* E01F	烛龙之护 */,
3	/* E11F	神羽 */,
3	/* E21F	灵梦 */,
3	/* E31F	武魂 */, };
