/************************************************
 *
 *       Filename: fileio.c
 *        Version: 0.2
 *         Author: little
 *     	      MSN: littlekrash@gmail.com
 *
 ***********************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include 	<time.h>
#include 	"fileio.h"
#include 	"search.h"
datInfo datInfoHdr = {NULL,0,NULL,0,NULL};		//头结点，没有内容
mBlock mBlock_hdr = {NULL,0,{'\0'}};

//添加标志，或者是计数结点到相应位置
void addDatInfo(datInfo *newNode)
{
	datInfo *p = &datInfoHdr;
	for(;p->next && INFO1(p->info) != INFO1(newNode->info);p = p->next);	
	if(p->next == NULL && INFO1(p->info) != INFO1(newNode->info)) {
		p->next = newNode;
	}
	else if(p->subLink == NULL) {
		p->subLink = newNode;
	}
	else {
		p = p->subLink;
		while(p->next) p = p->next;
		p->next = newNode;
	}
}

//查找标志，或者计数结点
datInfo *findDatInfo(unsigned int info)
{
	datInfo *p = &datInfoHdr;
	while(p->next && INFO1(p->info) != INFO1(info)) p = p->next;
	if(p->info == info) return p;
	else if(p->subLink == NULL) return NULL;
	else {
		p = p->subLink;
		while(p->next && p->info != info) {
			p = p->next;
		}
		if(p->info == info) return p;
		else return NULL;
	}
}

//加载存档
int loadDat(char *fname) {
	int fsize;		
	int	filerest; 
	FILE *fp;
	int size;
	if((fp = fopen(fname,"rb")) == NULL) 
		return EXIT_FAIL ;
	
	fseek(fp,0,SEEK_END);
	fsize = ftell(fp);
	rewind(fp);
	size = fsize;
	mBlock *bp,*proc;
	for( filerest = fsize ; filerest != 0 || filerest < 0; )
	{
		do {
			if( (bp = (mBlock *)malloc(sizeof(mBlock *) + sizeof(int) + 
							size*sizeof(char))) != NULL ) {
				bp->next = NULL;
				bp->size = size;
				size =  fread(bp->data,sizeof(char),size,fp);
				filerest -= size;
				break;
			}
		} while ( size /= 2 );
		size = filerest;
		proc = &mBlock_hdr;
		while(proc->next) proc = proc->next;
		proc->next = bp;
	}
	fclose(fp);
	return EXIT_OK;
}


//备份存档
void bakupFile(char *fname)
{
	char str[255 + 1];
	char *ptr;
	int len;
	time_t current;
	struct tm *local;
	FILE *fp;
	mBlock *proc;

	ptr = str;
	strcpy(ptr,fname);
	len = strlen(fname);
	ptr += len;
	current = time(NULL);
	local = localtime(&current);
	strftime(ptr,255 - len,"_%Y_%m_%d_%H_%M.bak",local);

	if((fp = fopen(str,"wb+")) != NULL) {
		proc = &mBlock_hdr;
		proc = proc->next;
		while(proc->next) {
			fwrite(proc->data,sizeof(char),proc->size,fp);
			proc = proc->next;
		}
		fwrite(proc->data,sizeof(char),proc->size,fp);
	}
	fclose(fp);
}
//读入存档
int initDatInfo() {
	int i,j,size,len;
	//为简单,只处理所有的要修改的属性在第一个mBlock里面
	if(mBlock_hdr.next) 
		if (search(mBlock_hdr.next->data,mBlock_hdr.next->size,flagString[215],strlen(flagString[215])) < 0) 
			return EXIT_FAIL;
	char *buf,*p;
	int magic = 217;
	buf = mBlock_hdr.next->data;
	//
	size = search(buf,0x10000,flagString[1],strlen(flagString[1]));
	size -= INTLEN;						//字符计数
	readBlock(buf,size,MAKE_INFO(NONE,TXT,NONE,magic));
	buf += size;
	
	magic++;

	//图谱
	size = search(buf,0x10000,flagString[2],strlen(flagString[2]));
	size -= INTLEN;
	readBlock(buf,size,MAKE_INFO(NONE,TXT,NONE,1));
	buf += size;

	//单独处理七个EC_SERIALIZE_FLAG块,buf现在指向第一个EC_SERIALIZE_FLAG的计数
	len = strlen(flagString[2]);
	p = buf + len + INTLEN;
	for(i = 1;i <= 6;i++) {
		size = search(p,0x10000,flagString[i + 1],len);
		size += len;
		readBlock(buf,size,MAKE_INFO(NONE,TXT,NONE,(i + 1)));
		buf += size;
		p = buf + INTLEN + len;
	}
	//buf现在指向最后一个EC_SERIALIZE_FLAG的计数
	size = search(buf,0x10000,flagString[9],strlen(flagString[9]));
	size -= INTLEN;						//字符计数
	readBlock(buf,size,MAKE_INFO(NONE,TXT,NONE,(i + 1)));
	buf += size;
	//读入每个人的属性,注意最后紫英的仙术技能块没有读入
	for(i = 1;i <= 4;i++) {
		for(j = 10;j <= 213;j++) {
			size = search(buf,0x200,flagString[j],strlen(flagString[j]));
			if(size > 0) {
				size -= INTLEN;						//字符计数
				readBlock(buf,size,MAKE_INFO(NONE,TXT,i,(j-1)));
				buf += size;
			}
		}
	}
	//在这里手动处理紫英仙术技能块,此时buf应该指向MGC_HOST_SER_FLAG的计数
	size = search(buf,0x200,flagString[214],strlen(flagString[214]));
	size -= 12;
	//212即是仙术技能块
	readBlock(buf,size,MAKE_INFO(NONE,TXT,4,212));
	buf += size;
	//读入这块余下
	int rest;
	rest = (mBlock_hdr.next->data + mBlock_hdr.next->size) - buf;
	if(rest > 0) 
	readBlock(buf,rest,MAKE_INFO(NONE,TXT,NONE,magic));


	//读入所有余下的
	mBlock *proc;
	proc = mBlock_hdr.next;
	proc = proc->next;
	if(proc) {
		for(;;) {
			magic++;
			readBlock(proc->data,proc->size,MAKE_INFO(NONE,TXT,NONE,magic));
			if(proc->next) proc = proc->next;
			else break;
		}
	}
	return EXIT_OK;
}
//读取指定长度内容，设定指定info
int readBlock(char *buf,int len,unsigned int info)
{
	datInfo *p;
	if(( p = (datInfo *) malloc(sizeof(datInfo))) == NULL ) 
		return EXIT_FAIL;
	p->next = NULL;
	p->size = len;
	p->data = buf;
	p->info = info;
	p->subLink = NULL;
	addDatInfo(p);
	return len;
};

//打包内容到结点
datInfo *getCell(char *buf,unsigned int info) {
	int n;
	datInfo *p;
	if( (p = (datInfo *)malloc(sizeof(datInfo)) ) == NULL ) return NULL;
	p->next = NULL;
	p->data = buf;
	p->info = info;
	p->subLink = NULL;
	switch (INFO2(info)) {
		case COUNTER_TP:
		case COUNTER_X:
		case COUNTER_J:
			p->size = INTLEN;
			break;
		case COUNTER_ZB:
			n = search(buf,0x200,"\x80\xfb\x12\x00\x04\x00\x00\x00\x07\x00\x00\x00",12);
			if(n == 0) p->size = 0;
			else p->size = n + 152;
			break;
		case COUNTER_WP:
			p->size = 3*INTLEN;
			break;
	}
	return p;
}
//初始化某计数器
int initCounter(char *buf,unsigned int info)
{
	int i;
	int num,size;
	char *temp;
	datInfo *p,*newCounter,*curr;
	newCounter = (datInfo *)malloc(sizeof(datInfo));
	if(newCounter == NULL) return EXIT_FAIL;
	newCounter->next = NULL;
	newCounter->data = buf;
	newCounter->size = INTLEN;
	newCounter->info = info;
	newCounter->subLink = NULL;

	addDatInfo(newCounter);

	temp = buf;
	num = STR2INT(buf);
	buf += INTLEN;

	curr = newCounter;

	if(num == 0) {
		if(INFO2(info) == COUNTER_X ) {
			p = getCell(buf,info);
			size = p->size;
			curr->subLink = p;
			curr = p;
			buf += size;
		}
	}
	else {
		if(INFO2(info) == COUNTER_X ) num = num * 3 + 1; //仙术
		for(i = 0;i < num;i++) {
			p = getCell(buf,info);
			size = p->size;
			curr->subLink = p;
			curr = p;
			buf += size;
		}
	}
	return (int)(buf - temp);
}
//调用上面函数初始化所有计数器
int initAllCounter()
{
	int len,num,size;
	int i,j;
	char *buf;
	datInfo *p,*first;
	
	first = &datInfoHdr;
	//读入图谱数据
	p = findDatInfo(MAKE_INFO(NONE,TXT,NONE,1) );
	len = INTLEN + STR2INT(p->data) + 2*INTLEN ;
	buf = p->data;
	p->size = len;
	buf += len;
	for(i = 1;i <= 3;i++) {
		size = initCounter(buf,MAKE_INFO(i,COUNTER_TP,NONE,1));
		buf += size;
	}

	readBlock(buf,INTLEN,MAKE_INFO(NONE,TXT,NONE,1));   //可恶的不知道含义的四字节

	//读入装备
	for(i = 1;i <= 7;i++) {
		p = findDatInfo(MAKE_INFO(NONE,TXT,NONE,(i + 1)) );
		len = INTLEN + STR2INT(p->data);
		buf = p->data;
		p->size = len;
		buf += len;
		size = initCounter(buf,MAKE_INFO(i,COUNTER_ZB,NONE,(i + 1)));
	}
	//处理物品前面的那一坨，buf指向最后一EC_SERIALIZE_FLAG的计数
	buf += size;
	num = STR2INT(buf);
	len = (num + 2) * INTLEN;
	readBlock(buf,len,MAKE_INFO(NONE,TXT,NONE,LAST_EC));
	buf += len;
	//读入物品
	num = STR2INT(buf);
	if(num) {
		readBlock(buf,INTLEN,MAKE_INFO(NONE,COUNTER_WP,NONE,LAST_EC));
		buf += INTLEN;
		for(i = 1;i <= 5;i++) {
			size = initCounter(buf,MAKE_INFO(i,COUNTER_WP,NONE,LAST_EC));
			buf += size;
			readBlock(buf,INTLEN,MAKE_INFO(NONE,TXT,NONE,LAST_EC));		//可恶的不知道含义的四字节
			buf += INTLEN;
		}
		num = STR2INT(buf);
		len = (num + 2) * INTLEN;
		readBlock(buf,len,MAKE_INFO(NONE,TXT,NONE,LAST_EC));
	}
	//人物仙术,技能
	for(i = 1;i <= 4;i++) {
		p = findDatInfo(MAKE_INFO(NONE,TXT,i,212));
		len = INTLEN + STR2INT(p->data);
		buf = p->data;
		p->size = len;
		buf += len;
		for(j = 1;j <= 5;j++) {
			size = initCounter(buf,MAKE_INFO(j,COUNTER_X,i,212));
			buf += size;
		}
		initCounter(buf,MAKE_INFO(NONE,COUNTER_J,i,212));
	}
	return EXIT_OK;
}



void writeDatInfo(datInfo *p,FILE *fp)
{
	if(p == NULL) return;
	fwrite(p->data,sizeof(char),p->size,fp);
	writeDatInfo(p->subLink,fp);
	writeDatInfo(p->next,fp);
}
int saveDat(char *fname) {
	FILE *fp;
	datInfo	 *proc;
	if((fp = fopen(fname,"wb+")) == NULL)
		return EXIT_FAIL ;
	proc = datInfoHdr.next;
	if(proc) {
		writeDatInfo(proc,fp);
	}
	return EXIT_OK;
}
void freeDatInfo(datInfo *p) {
	if(p == NULL) return;
	freeDatInfo(p->subLink);
	freeDatInfo(p->next);
	free(p);
}
void freeFile() {
	mBlock *p,*proc;
	proc = &mBlock_hdr;
	proc = proc->next;
	while(proc->next) {
		p = proc;
		proc = proc->next;
		free(p);
	}
	free(proc);
}
char *flagString[216] = {
/* 0 */		"",
/* 1 */		"money",
/* 2 */		"EC_SERIALIZE_FLAG",
/* 3 */		"EC_SERIALIZE_FLAG",
/* 4 */		"EC_SERIALIZE_FLAG",
/* 5 */		"EC_SERIALIZE_FLAG",
/* 6 */		"EC_SERIALIZE_FLAG",
/* 7 */		"EC_SERIALIZE_FLAG",
/* 8 */		"EC_SERIALIZE_FLAG",
/* 9 */		"P_MGR_SERIALIZE_FLAG",
/* 10 */		"PR_SERIALIZE_FLAG",
/* 11 */		"BASICT",							//??它的字符计数是5
/* 12 */		"AI_TYPE",
/* 13 */		"CA_ADDITIONAL_CRITICAL",
/* 14 */		"CA_ADDITIONAL_HITTING",
/* 15 */		"CA_ADDITIONAL_RAGE",
/* 16 */		"CA_ATTACK_AIR_ADDITIONAL",
/* 17 */		"CA_ATTACK_AIR_EXTRACT",
/* 18 */		"CA_ATTACK_AIR_REACT",
/* 19 */		"CA_ATTACK_EARTH_ADDITIONAL",
/* 20 */		"CA_ATTACK_EARTH_EXTRACT",
/* 21 */		"CA_ATTACK_EARTH_REACT",
/* 22 */		"CA_ATTACK_FIRE_ADDITIONAL",
/* 23 */		"CA_ATTACK_FIRE_EXTRACT",
/* 24 */		"CA_ATTACK_FIRE_REACT",
/* 25 */		"CA_ATTACK_PHYSICAL_ADDITIONAL",
/* 26 */		"CA_ATTACK_PHYSICAL_EXTRACT",
/* 27 */		"CA_ATTACK_PHYSICAL_REACT",
/* 28 */		"CA_ATTACK_THUNDER_ADDITIONAL",
/* 29 */		"CA_ATTACK_THUNDER_EXTRACT",
/* 30 */		"CA_ATTACK_THUNDER_REACT",
/* 31 */		"CA_ATTACK_WATER_ADDITIONAL",
/* 32 */		"CA_ATTACK_WATER_EXTRACT",
/* 33 */		"CA_ATTACK_WATER_REACT",
/* 34 */		"CA_COUNTERPUNCH_RATE",
/* 35 */		"CA_EXPERIENCE",
/* 36 */		"CA_FEND_OFF",
/* 37 */		"CA_HP",
/* 38 */		"CA_HP_REGAIN_PARAM",
/* 39 */		"CA_LEVEL",
/* 40 */		"CA_LOSABLE_MONEY",
/* 41 */		"CA_LOSABLE_PROPERTY",
/* 42 */		"CA_LUCKY",
/* 43 */		"CA_MAGIC_ATTACK_PARAM",
/* 44 */		"CA_MAGIC_POINT",
/* 45 */		"CA_MAX_HP",
/* 46 */		"CA_MAX_MP",
/* 47 */		"CA_MP",
/* 48 */		"CA_MP_REGAIN_PARAM",
/* 49 */		"CA_MULTI_HIT",
/* 50 */		"CA_PAY_FOR_SPARE",
/* 51 */		"CA_PHYSICAL",
/* 52 */		"CA_PHYSICAL_ATTACK_PARAM",
/* 53 */		"CA_RAGE",
/* 54 */		"CA_SPEED",
/* 55 */		"CA_THE_LOSABLE_NUMBER",
/* 56 */		"CA_TOUGHNESS",
/* 57 */		"CA_WILL",
/* 58 */		"COMBAT_POSITION",
/* 59 */		"EASA_AIR_IMMUNITY",
/* 60 */		"EASA_EARTH_IMMUNITY",
/* 61 */		"EASA_FIRE_IMMUNITY",
/* 62 */		"EASA_NONE_IMMUNITY",
/* 63 */		"EASA_THUNDER_IMMUNITY",
/* 64 */		"EASA_WATER_IMMUNITY",
/* 65 */		"EASB_BONDAGE_IMMUNITY",
/* 66 */		"EASB_DISORDER_IMMUNITY",
/* 67 */		"EASB_FORBIDEN_IMMUNITY",
/* 68 */		"EASB_MAD_IMMUNITY",
/* 69 */		"EASB_NONE_IMMUNITY",
/* 70 */		"EASB_SEAL_IMMUNITY",
/* 71 */		"EASB_SLEEP_IMMUNITY",
/* 72 */		"EAST_A",
/* 73 */		"EAST_B",
/* 74 */		"EAST_C",
/* 75 */		"EAST_D",
/* 76 */		"EAST_E",
/* 77 */		"EAST_F",
/* 78 */		"EAST_G",
/* 79 */		"EAST_H",
/* 80 */		"EAST_I",
/* 81 */		"EFE_AIR",
/* 82 */		"EFE_EARTH",
/* 83 */		"EFE_FIRE",
/* 84 */		"EFE_THUNDER",
/* 85 */		"EFE_WATER",
/* 86 */		"ERR_BEAST_RACE_ATK",
/* 87 */		"ERR_DEMON_RACE_ATK",
/* 88 */		"ERR_FAIRY_RACE_ATK",
/* 89 */		"ERR_GHOST_RACE_ATK",
/* 90 */		"ERR_HUMAN_RACE_ATK",
/* 91 */		"ERR_IMMORTAL_RACE_ATK",
/* 92 */		"ERR_SPIRIT_RACE_ATK",
/* 93 */		"ESI_MORTAL",
/* 94 */		"ESI_SIPHON",
/* 95 */		"RACE",
/* 96 */		"Playerr",				//??
/* 97 */		"AI_TYPE",
/* 98 */		"CA_ADDITIONAL_CRITICAL",
/* 99 */		"CA_ADDITIONAL_HITTING",
/* 100 */		"CA_ADDITIONAL_RAGE",
/* 101 */		"CA_ATTACK_AIR_ADDITIONAL",
/* 102 */		"CA_ATTACK_AIR_EXTRACT",
/* 103 */		"CA_ATTACK_AIR_REACT",
/* 104 */		"CA_ATTACK_EARTH_ADDITIONAL",
/* 105 */		"CA_ATTACK_EARTH_EXTRACT",
/* 106 */		"CA_ATTACK_EARTH_REACT",
/* 107 */		"CA_ATTACK_FIRE_ADDITIONAL",
/* 108 */		"CA_ATTACK_FIRE_EXTRACT",
/* 109 */		"CA_ATTACK_FIRE_REACT",
/* 110 */		"CA_ATTACK_PHYSICAL_ADDITIONAL",
/* 111 */		"CA_ATTACK_PHYSICAL_EXTRACT",
/* 112 */		"CA_ATTACK_PHYSICAL_REACT",
/* 113 */		"CA_ATTACK_THUNDER_ADDITIONAL",
/* 114 */		"CA_ATTACK_THUNDER_EXTRACT",
/* 115 */		"CA_ATTACK_THUNDER_REACT",
/* 116 */		"CA_ATTACK_WATER_ADDITIONAL",
/* 117 */		"CA_ATTACK_WATER_EXTRACT",
/* 118 */		"CA_ATTACK_WATER_REACT",
/* 119 */		"CA_COUNTERPUNCH_RATE",
/* 120 */		"CA_EXPERIENCE",
/* 121 */		"CA_FEND_OFF",
/* 122 */		"CA_HP",
/* 123 */		"CA_HP_REGAIN_PARAM",
/* 124 */		"CA_LEVEL",
/* 125 */		"CA_LOSABLE_MONEY",
/* 126 */		"CA_LOSABLE_PROPERTY",
/* 127 */		"CA_LUCKY",
/* 128 */		"CA_MAGIC_ATTACK_PARAM",
/* 129 */		"CA_MAGIC_POINT",
/* 130 */		"CA_MAX_HP",
/* 131 */		"CA_MAX_MP",
/* 132 */		"CA_MP",
/* 133 */		"CA_MP_REGAIN_PARAM",
/* 134 */		"CA_MULTI_HIT",
/* 135 */		"CA_PAY_FOR_SPARE",
/* 136 */		"CA_PHYSICAL",
/* 137 */		"CA_PHYSICAL_ATTACK_PARAM",
/* 138 */		"CA_RAGE",
/* 139 */		"CA_SPEED",
/* 140 */		"CA_THE_LOSABLE_NUMBER",
/* 141 */		"CA_TOUGHNESS",
/* 142 */		"CA_WILL",
/* 143 */		"CombatPosition",
/* 144 */		"EASA_AIR_IMMUNITY",
/* 145 */		"EASA_EARTH_IMMUNITY",
/* 146 */		"EASA_FIRE_IMMUNITY",
/* 147 */		"EASA_NONE_IMMUNITY",
/* 148 */		"EASA_THUNDER_IMMUNITY",
/* 149 */		"EASA_WATER_IMMUNITY",
/* 150 */		"EASB_BONDAGE_IMMUNITY",
/* 151 */		"EASB_DISORDER_IMMUNITY",
/* 152 */		"EASB_FORBIDEN_IMMUNITY",
/* 153 */		"EASB_MAD_IMMUNITY",
/* 154 */		"EASB_NONE_IMMUNITY",
/* 155 */		"EASB_SEAL_IMMUNITY",
/* 156 */		"EASB_SLEEP_IMMUNITY",
/* 157 */		"EAST_A",
/* 158 */		"EAST_B",
/* 159 */		"EAST_C",
/* 160 */		"EAST_D",
/* 161 */		"EAST_E",
/* 162 */		"EAST_F",
/* 163 */		"EAST_G",
/* 164 */		"EAST_H",
/* 165 */		"EAST_I",
/* 166 */		"EFE_AIR",
/* 167 */		"EFE_EARTH",
/* 168 */		"EFE_FIRE",
/* 169 */		"EFE_THUNDER",
/* 170 */		"EFE_WATER",
/* 171 */		"EMS_DIG_MINE",
/* 172 */		"EMS_EXPLORE_CASE",
/* 173 */		"EMS_EXPLORE_MINE",
/* 174 */		"EMS_PROBE_TREASURE",
/* 175 */		"EMS_SCATTER_POISON",
/* 176 */		"EMS_TRAP",
/* 177 */		"EMS_UNLOCK_CASE",
/* 178 */		"ERES_CORSELET",
/* 179 */		"ERES_HELMENT",
/* 180 */		"ERES_LEGHARNESS",
/* 181 */		"ERES_ORNAMENT1",
/* 182 */		"ERES_ORNAMENT2",
/* 183 */		"ERES_WEAPON",
/* 184 */		"ERR_BEAST_RACE_ATK",
/* 185 */		"ERR_DEMON_RACE_ATK",
/* 186 */		"ERR_FAIRY_RACE_ATK",
/* 187 */		"ERR_GHOST_RACE_ATK",
/* 188 */		"ERR_HUMAN_RACE_ATK",
/* 189 */		"ERR_IMMORTAL_RACE_ATK",
/* 190 */		"ERR_SPIRIT_RACE_ATK",
/* 191 */		"ESI_MORTAL",
/* 192 */		"ESI_SIPHON",
/* 193 */		"InTeam",
/* 194 */		"PHYSICAL_ATK_RANGE",
/* 195 */		"PHYSICAL_ATK_TARGET",
/* 196 */		"PLAYER_TYPE",
/* 197 */		"RA_ICON",
/* 198 */		"RA_MODEL",
/* 199 */		"RA_NAME",
/* 200 */		"RA_TEXTURE",
/* 201 */		"ROLE_RACE",
/* 202 */		"SOUND_WOUNDED1",
/* 203 */		"SOUND_WOUNDED2",
/* 204 */		"SOUND_WOUNDED3",
/* 205 */		"SOUND_WOUNDED4",
/* 206 */		"SOUND_WOUNDED5",
/* 207 */		"ePT_LINSHA_FAVOR",
/* 208 */		"ePT_MENGLI_FAVOR",
/* 209 */		"ePT_TIANHE_FAVOR",
/* 210 */		"ePT_ZIYING_FAVOR",
/* 211 */		"ForbidenSkill",
/* 212 */		"MGC_HOST_SER_FLAG",
/* 213 */		"PR_SERIALIZE_FLAG",		//加这行是为了好处理
/* 214 */		"P_MGR",
/* 215 */		"CameraAutoSeek"};			//BM算法在搜索长字符串比短的高效
