/************************************************
 *
 *       Filename: fileio.h
 *        Version: 0.2
 *         Author: little
 *    	      MSN: littlekrash@gmail.com
 *
 ***********************************************/

#ifndef __FILEIO_H__
#define __FILEIO_H__

#define EXIT_OK		1
#define EXIT_FAIL	0	

#define TXT 1						//标志字符串
#define COUNTER_TP 	2					//图谱计数器
#define COUNTER_ZB	3					//装备计数器
#define COUNTER_WP	4					//物品计数器
#define COUNTER_X	5					//仙术计数器
#define COUNTER_J	6					//技能计数器

#define NONE	0

#define RONGZHU	1
#define	DUANYE 	2
#define ZHULIN	3

#define EC_1	1
#define EC_2	2
#define EC_3	3
#define EC_4	4
#define EC_5 	5
#define EC_6	6
#define EC_7	7
#define LAST_EC 8

#define RECOVER 	1
#define ATTACK  	2	
#define ASSIST 		3
#define STUFF		4
#define STORY		5

#define TIANHE	1
#define LINSHA	2
#define MENGLI	3
#define ZIYING	4 

#define WATER	1
#define FIRE	2
#define AIR		3
#define THUNDER 4
#define EARTH	5
#define SKILL	6

#define INTLEN  4
#define STR2INT(str) (*(int*)(str))
#define MAKE_INFO(INFO4,INFO3,INFO2,INFO1) ( (INFO4 << 24) | (INFO3 << 16) |\
											 (INFO2 << 8) | INFO1)
#define INFO1(info) ((info) & 0xFFFF)
#define INFO2(info) (((info) >> 16) & 0xFF)
#define INFO3(info) (((info) >> 24) & 0xFF)
//存档保存在这样的结构中
typedef struct mBlock_t mBlock;
typedef struct item_t item;
typedef struct datInfo_t datInfo;
struct mBlock_t {
	mBlock *next;
	int size;
	char data[1];				
};
//物品
struct item_t {
	int serial;
	int num;
	int ID;
};

//用来组织mBlock_t的结构
struct datInfo_t {
	datInfo *next;
	int size;
	char *data;
	unsigned int info;			//|子类|主类|主角|索引| 	
	datInfo *subLink;
};
extern datInfo datInfoHdr;
extern mBlock mBlock_hdr;
extern char *flagString[216];
int initAllCounter();
int initDatInfo() ;
int loadDat(char *fname) ;
int readBlock(char *buf,int len,unsigned int info);
int saveDat(char *fname) ;
void bakupFile(char *fname);
void freeDatInfo(datInfo *p);
void freeFile();
datInfo *findDatInfo(unsigned int info);
#endif
